unit al68idepas;

{$mode objfpc}{$H+}
//Ride for red - converted from delphi to lazarus - mike parr Jan 2021
//mikeparr@live.com
//use the source as you wish, but you cannot sell it.
                                      //todo delete other forms and code
interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Process, Dialogs, LCLType,
  ExtCtrls, StdCtrls, Menus, PairSplitter, SynMemo, SynHighlighterJava, lclintf {form};

 type

  { TTMainForm }

  TTMainForm = class(TForm)
  newUnitpp: TButton;
  ChooseRedInterp: TMenuItem;
  helpOnGogoMenu: TMenuItem;
  newGoFileClick: TMenuItem;
    ChooseInterp: TMenuItem;
    ShowChosenInterp: TMenuItem;
    MenuItem4: TMenuItem;
    helpOnRideMenu: TMenuItem;
    selectAllMenu: TMenuItem;
    showCommLineArgsMenu: TMenuItem;
    setCommandLineArgsClick: TMenuItem;
    runButton: TButton;
    errorListBox: TListBox;
    FindDialog1: TFindDialog;
    MainMenu1: TMainMenu;
    MenuItem1: TMenuItem;
    exitMenuItem: TMenuItem;
    MenuItem2: TMenuItem;
    cutMenuItem: TMenuItem;
    copyMenuItem: TMenuItem;
    findMenuItem: TMenuItem;
    MenuItem3: TMenuItem;
    biggerTextmenuItem: TMenuItem;
    OpenDialogExe: TOpenDialog;
    smallerTextMenuItem: TMenuItem;
    ReplaceDialog1: TReplaceDialog;
    undoMenuItem: TMenuItem;
    replaceMenuItem: TMenuItem;
    pasteMenuItem: TMenuItem;
    saveAsMenuItem: TMenuItem;
    saveMenuItem: TMenuItem;
    OpenDialog: TOpenDialog;
    openMenuItem: TMenuItem;
    newFileClick: TMenuItem;
    PairSplitter1: TPairSplitter;
    PairSplitterSide1: TPairSplitterSide;
    PairSplitterSide2: TPairSplitterSide;
    Panel1: TPanel;
    Panel2: TPanel;
    editWin: TSynMemo;
    SaveDialog: TSaveDialog;
    SynJavaSyn1: TSynJavaSyn;
    procedure biggerTextmenuItemClick(Sender: TObject);
    procedure bracketsButtonClick(Sender: TObject);
    procedure closeMenuClick(Sender: TObject);
    procedure ChooseRedInterpClick(Sender: TObject);
    procedure CompileButtonClick(Sender: TObject);
    procedure consoleButtonClick(Sender: TObject);
    procedure FragmentsButtonClick(Sender: TObject);
    procedure newUnitppClick(Sender: TObject);
    procedure PairSplitterSide1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PairSplitterSide2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure redConsoleClick(Sender: TObject);
    procedure RunExeButtonClick(Sender: TObject);
    procedure ShowChosenInterpClick(Sender: TObject);
    procedure runButtonClick(Sender: TObject);
    procedure fmtButton1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: boolean);
    procedure helpOnRideMenuClick(Sender: TObject);
    procedure copyMenuItemClick(Sender: TObject);
    procedure cutMenuItemClick(Sender: TObject);
    procedure editWinChange(Sender: TObject);
    procedure exitMenuItemClick(Sender: TObject);
    procedure findMenuItemClick(Sender: TObject);
    procedure newFileClickClick(Sender: TObject);
    procedure openMenuItemClick(Sender: TObject);
    procedure pasteMenuItemClick(Sender: TObject);
    procedure replaceMenuItemClick(Sender: TObject);
    procedure saveAsMenuItemClick(Sender: TObject);
    procedure ReplaceDialog1Replace(Sender: TObject);
    procedure ReplaceDialog1Find(Sender: TObject);
    procedure FindDialog1Find(Sender: TObject);
    function SaveFileAs(nameToShow:string) : integer;
    function OKtoCloseCurrentDoc : boolean;
    procedure saveMenuItemClick(Sender: TObject);
    procedure selectAllMenuClick(Sender: TObject);
    procedure setCommandLineArgsClickClick(Sender: TObject);
    procedure showCommLineArgsMenuClick(Sender: TObject);
    procedure smallerTextMenuItemClick(Sender: TObject);
    procedure SpellCrossRefClick(Sender: TObject);
    procedure undoMenuItemClick(Sender: TObject);
    procedure  interpretApplic;
    procedure FormCreate(Sender: TObject);
    procedure doFormat;
    procedure XrefSpellButtonClick(Sender: TObject);

private
    { private declarations }

commandLineArgs:string;
fileNameWithPath : string;         // e.g  c:\myfiles\fred.red
batFile:textfile;
a68Compiler:string;      // e.g  c:\a68stuff\Algol68.exe
IDEDirectory:string;     // the working dir of the IDE-so it can find its helper files
initialUserDir:string;   // user's initial open/save dir
outFile:textfile;
inFile:textfile;
ppStatus: textfile;

// --- Save and Close
procedure SetFileName( fn : string );
procedure ClearEditWin;
procedure DoSaveFile;
function  ConfirmFileSave( fn, msg : string) : integer;
function SaveFile : integer;    //what is this?
function setupOK:boolean;

function ReplaceIn(SearchFor, ReplaceStr, Str : String): String;

  public
    { public declarations }
  end; 
  //----------------------------------------------------------------------------
var
  TMainForm: TTMainForm;

     //These 2 vars for search/replace dialogs
     fPos:integer;
     found:boolean;


const
   TAB = #09;
   CR  = #13;
   LF  = #10;
   CRLF = CR + LF;  //laz
      qu = '"';    //for eg dos file names qith spaces in them

   EOL = #10;  //linux

   NEWFILENAME = 'Untitled';
   APPNAME = 'Algol68';

   FILEOVERWRITEMSG = '%s already exists. OK to overwrite?';
   FILESAVEMSG = 'Save changes to %s?';

implementation
{$R *.lfm}

//-----------------------------------------------------------------

procedure TTMainForm.SetFileName( fn : string );
begin
   fileNameWithPath := fn;
   Caption := Format('%s : [%s]', [APPNAME,ExtractFileName(fn)]);

end;

//------------------------------------------------------------------------------

procedure TTMainForm.ClearEditWin;
begin
  EditWin.Lines.Clear;
  EditWin.Modified := False;
  SetFileName('');
end;

//------------------------------------------------------------------------------

function TTMainForm.ConfirmFileSave( fn, msg : string ) : integer;
var
  savechoice : integer;

  begin
    savechoice := MessageDlg(Format(FILESAVEMSG, [ExtractFileName(fn)]),
      mtConfirmation, mbYesNoCancel, 0);  //laz
    case savechoice of
      IDYES: result := IDYES;
      IDNO: result := IDNO;
      IDCANCEL: result := IDCANCEL;
      else result := 0;
    end;
end;

//-----------------------------------------------------------------------------
procedure TTMainForm.DoSaveFile;
begin
  if fileNameWithPath <>'' then begin
      EditWin.Lines.SaveToFile( fileNameWithPath);
      EditWin.Modified := False;
  end;
end;

//-----------------------------------------------------------------------------

function TTMainForm.SaveFile : integer;   //TResponse;
var
   saveit : integer;   //TResponse;
begin
  saveit := IDYES;
  if (ExtractFileName(fileNameWithPath) = NEWFILENAME)
   or (ExtractFileName(fileNameWithPath) = '')  //added by mike
  then  //OK?? what if dif folders?
    saveit := SaveFileAs ('')
  else
    DoSaveFile;
    result := saveit;
end;
//-------------------------------------------------------------------------------

{ The function searches for a substring 'SearchFor' in a string
  'Str' and replaces all found substrings by 'ReplaceStr'
  It is NOT used by the dialogs. }

function TTMainForm.ReplaceIn(SearchFor, ReplaceStr, Str : String): String;
var
  Dummy, st : String;
  i : integer;
begin
  { make a temp. copy of the Str }
  st := Str;
  { first position of the substring }
  i := Pos(SearchFor, St);
  Dummy := '';

  { search lasts while the specified substring is found }
  while i <> 0 do
  begin
    Dummy := Dummy + Copy(St, 0, i - 1) + ReplaceStr;
    st := copy(st, i + length(SearchFor), length(st)+1);
    i := Pos(SearchFor, St);
  end;

  { result: the substrings replaced by 'ReplaceStr' }
  result := Dummy + st;
end;

//-----------------------------------------------------------------------------

function TTMainForm.OKtoCloseCurrentDoc : boolean;
var
   docloseIt, dosaveIt : integer;     //laz clash - remamed these
begin
   if fileNamewithPath <>'' then  begin
      docloseIt := IDYES;
       dosaveIt := IDNO;
       if EditWin.Modified then
       case ConfirmFileSave( ExtractFileName(fileNameWithPath), FILESAVEMSG ) of   //laz
          IDYES: dosaveIt := SaveFile;
          IDNO, 0 : { do nothing } ;    //laz - ok?
          IDCANCEL: docloseIt := IDNO;
       end;
       if (docloseIt = IDYES) and (dosaveIt <> IDCANCEL) then
          result := true
       else
          result := false
   end
   else
       result:=true;   // when no file name - ved

end;

//---------------------------------------------------------------------------

function TTMainForm.SaveFileAs(nameToShow:string): integer;
var
   saveit : integer;
   saveAnswer:boolean;
begin
  saveit := IDYES;     //laz
  //ved
  If nameToShow <> '' then
     SaveDialog.filename:=nameToShow;

 saveAnswer:= SaveDialog.Execute;
   if saveAnswer then
       begin

       if FileExists(SaveDialog.FileName) then
            saveit := ConfirmFileSave(SaveDialog.FileName, FILEOVERWRITEMSG); //laz

       if saveit = IDYES then     //laz
            begin
                SetFileName(SaveDialog.FileName);
                DoSaveFile;   // problem if user cancels while creating a new applic/applet
             end;
  end
  else saveit := IDCANCEL;  //laz
  result := saveit;
end;
//-----------------------------------------------------------------------------

function TTMainform.setupOK:boolean;       // 2 cases
begin
if fileNameWithPath ='' then begin
    showMessage('No saved program !');
    setupOK:=false;
    end
 else setupOK:=true;
end;

//----------------------------------------------------------------------------

procedure TTMainForm.saveMenuItemClick(Sender: TObject);
begin
  SaveFile;
end;
//-----------------------------------------------------------------------------

procedure TTMainForm.selectAllMenuClick(Sender: TObject);
begin
editwin.selectAll;
end;

//-----------------------------------------------------------------------------

procedure TTMainForm.setCommandLineArgsClickClick(Sender: TObject);
var clickedOK:boolean;
mess:string;
begin
mess:= 'Enter command-line args';

ClickedOK := InputQuery('Enter Command-Line Args', mess, commandLineArgs);
end;
//-----------------------------------------------------------------------------

procedure TTMainForm.showCommLineArgsMenuClick(Sender: TObject);
begin
if commandLineArgs='' then
    showmessage('Command line args are unset.')
else
        showmessage('Command line args are:'+EOL+EOL+commandLineArgs);
end;

//------------------------------------------------------------------------------
procedure TTMainForm.openMenuItemClick(Sender: TObject);
begin

  if  OKtoCloseCurrentDoc then
      if OpenDialog.Execute then

            begin  {ok to open... }
             ErrorListBox.clear;
             EditWin.Lines.LoadFromFile(OpenDialog.FileName);
             SetFileName(OpenDialog.FileName);  // sets FileName with path!
             EditWin.SetFocus;
             EditWin.Modified := True;      // new code
   end;
end;
//-----------------------------------------------------------------------------

//------------------ begin search/replace stuff ------------------------------------

//replacement for selLength prop - linux synedit doesnt have it - mike
procedure setSelLength(var textComponent:TSynMemo; newValue:integer);
begin
textComponent.SelEnd:=textComponent.SelStart+newValue ;
end;
//----------------------------------------------------------------------------

procedure TTMainForm.ReplaceDialog1Find(Sender: TObject);    //yes, IS used by Laz
var
  FindS: String;
  IPos, FLen, SLen: Integer; {Internpos, Lengde søkestreng, lengde memotekst}
  Res : integer;
begin
  {FPos is global}
  Found:= False;
  FLen := Length(ReplaceDialog1.FindText);
  SLen := Length(editWin.Text);
  FindS := ReplaceDialog1.FindText;

 //following 'if' added by mike
  if frMatchcase in ReplaceDialog1.Options then
     IPos := Pos(FindS, Copy(editWin.Text,FPos+1,SLen-FPos))
  else
     IPos := Pos(AnsiUpperCase(FindS),AnsiUpperCase( Copy(editWin.Text,FPos+1,SLen-FPos)));

  If IPos > 0 then begin
    FPos := FPos + IPos;
 //   Hoved.BringToFront;       {Edit control must have focus in } - what is this? mike
    editWin.SetFocus;
    Self.ActiveControl := editWin;
    editWin.SelStart:= FPos;  // removed -1;   mike   {Select the string found by POS}
    setSelLength(editWin, FLen);     //editWin.SelLength := FLen;
    Found := True;
    FPos:=FPos+FLen-1;   //mike - move just past end of found item
  end
  Else
  begin
    If not (ReplaceDialog1.Options*[frReplaceAll] = [frReplaceAll]) then
      Res := Application.MessageBox('Text was not found!', 'Replace',
      mb_OK + mb_ICONWARNING);
    FPos := 0;     //mike  nb user might cancel dialog, so setting here is not enough
  end;             //   - also do it before exec of dialog.

 end;
 //-----------------------------------------------------------------------------

procedure TTMainForm.ReplaceDialog1Replace(Sender: TObject);
var
    Res, replaceCount:integer;   //added by mike
    countInfo:string;
begin
  If Found = False then       {If no search for string took place}
  begin
    ReplaceDialog1Find(Sender); {Search for string, replace if found}
    If Length(editWin.SelText) > 0 then
        editWin.SelText :=  ReplaceDialog1.ReplaceText;
  end
  Else                          {If search ran, replace string}
  begin
    If Length(editWin.SelText) > 0 then
        editWin.SelText := ReplaceDialog1.ReplaceText;
  end;
  Found := False;
  setSelLength(editWin, 0);    //editWin.SelLength := 0;
  {Hvis Erstatt alle...}
  If (ReplaceDialog1.Options*[frReplaceAll] = [frReplaceAll]) then begin
      replaceCount:=0;
      Repeat
        ReplaceDialog1Find(Sender); {Search for string, replace if found}
        If Length(editWin.SelText) > 0 then begin
            editWin.SelText := ReplaceDialog1.ReplaceText;
            replaceCount:=replaceCount+1;
        end;                                   //laz, syn
     until Found = False;
      if replaceCount>0 then
         replaceCount:=replaceCount+1;   //the first 1, then loop for rest  - mike
      countInfo:=inttostr(replaceCount)+'  replacements made.';
      Res := Application.MessageBox(pchar(countInfo),
             'Replace', mb_OK + mb_ICONINFORMATION);

  end;
end;

//--------------------------------------------------------------------------------

procedure TTMainForm.FindDialog1Find(Sender: TObject);  //based on replaceD1find
var
  FindS: String;
  IPos, FLen, SLen: Integer; {Internpos, Lengde søkestreng, lengde memotekst}
  Res : integer;
begin
  {FPos is global}
  Found:= False;
  FLen := Length(findDialog1.FindText);
  SLen := Length(editWin.Text);
  FindS := findDialog1.FindText;

 //following 'if' added by mike
  if frMatchcase in findDialog1.Options then
     IPos := Pos(FindS, Copy(editWin.Text,FPos+1,SLen-FPos))
  else
     IPos := Pos(AnsiUpperCase(FindS),AnsiUpperCase( Copy(editWin.Text,FPos+1,SLen-FPos)));

  If IPos > 0 then begin
    FPos := FPos + IPos;
 //   Hoved.BringToFront;       {Edit control must have focus in }
    editWin.SetFocus;
    Self.ActiveControl := editWin;
    editWin.SelStart:= FPos;  // -1;   mike   {Select the string found by POS}
    setSelLength(editWin, FLen);     //editWin.SelLength := FLen;
    Found := True;
    FPos:=FPos+FLen-1;   //mike - move just past end of found item

  end
  Else
  begin
    Res := Application.MessageBox('Text was not found!',
           'Find',  mb_OK + mb_ICONWARNING);
    FPos := 0;     //mike  nb user might cancel dialog, so setting here is not enough
  end;             //   - also do it before exec of dialog.

end;

//-----------------------------end sarch/rep stuff -----------------------------

procedure TTMainForm.saveAsMenuItemClick(Sender: TObject);
begin
 SaveFileAs('');
end;
//-----------------------------------------------------------------------------

procedure TTMainForm.interpretApplic;      // - Aprocess not used now

var compilername,line ,params, userFileFolder :string;
begin
params:='';
Assignfile(batFile,'comperrs.txt');
ErrorListBox.Clear;
userFileFolder:=ExtractFileDir(fileNameWithPath);
EditWin.Lines.SaveToFile(fileNameWithPath);
EditWin.modified:=false;
//showmessage('uff= '+userFileFolder);
Assignfile(batFile, userFileFolder+ '\docomp.bat');
rewrite(batfile);
line:='"'+a68Compiler+'"'+  params +
       ' "'+fileNameWithPath+'"' +' '+ commandLineArgs;
//showmessage(line);
writeln(batfile,line);
writeln(batfile, 'pause');
closeFile(batFile);
SetCurrentDir(userFileFolder);
openDocument(userfilefolder+'\docomp.bat');
end;

//=----------------------------------------------------------------------------

procedure TTMainForm.runButtonClick(Sender: TObject);
begin
//run a68 prog
if fileNameWithPath ='' then
   showMessage('No a68 program !  (not saved?)')
else if a68Compiler ='' then
   showmessage('No a68 system available - please see:  Tools | Configure.')

else if fileNamewithPath<>'' then
  interpretApplic; //was compileapplic
end;
//-----------------------------------------------------------------------------

procedure TTMainForm.fmtButton1Click(Sender: TObject);
begin
doFormat;
end;

//-------------------------------------------------------------------------------

procedure TTMainForm.doFormat;  //pretty  NB this code not used now, I run a68pp
{  note on timing issues
Overall logic is:

10  editor writes (ie save) the editor screen to afile
20  run bat with opendocument
30  bat file calls an exe, which reads the saved file
40  the exe writes to  a new file
50  bat ends, now back in the editor, which reads (reloads) file

Problem:  noticed at times
bat can read file before editor finishes writing
editor can read file before exe finishes.

Solution 1 - works, not best
time delay in editor at lines  15   45

Solution 2  -did not work!!!
In editor at line 15 , read and close file
    (should ensure that previous writing is done
   In exe, read/close the just saved file - no, not neded todo del

}
{bug - saved a68 file is ok, safecopy is ok, resultfile is ok, BUT
screen has aline missing
}

//use of sleep() is the only fix I've found that works

var
    line, dummy :string;
    userFileFolder:string;
    copyResult:boolean;
    errline, allMessage: string;
begin
if a68Compiler='' then
      showMessage('Algol68 system is unconfigured - use Tools menu.')
else begin
If  fileNameWithPath <>'' then begin   //work to do
    userFileFolder:=ExtractFileDir(fileNameWithPath);
    EditWin.Lines.SaveToFile( fileNameWithPath);
    EditWin.Modified := False;

    //COPY ORIG, SO IT IS SAFE IN CASE OF DISASTER
   copyResult:=CopyFile(pchar(fileNameWithPath),
                         pchar(userFileFolder+'.\safeOriginal.a68'),
                         false);   //overwrite
    if copyResult=false then
        showmessage('copy is false when running pretty bat - a68ide system error!')
    else  begin
        Assignfile(batFile,'.\dorun-a68pp.bat');
        rewrite(batFile);
        line:='"a68pretty.exe"  '
            + fileNameWithPath ; //should be same as ide dir  -true? todo
        writeln(batfile,line);
        closeFile(batFile);
        chdir(IDEdirectory);
         sleep(400);   //not needed in tests, might be for large files
        openDocument('.\dorun-a68pp.bat');          //define at top of proc
        sleep(600);        //seems ok    300 was 0k, but allowing a bit of safety

        //look in the ppStatus file created by pretty, for error info
        Assignfile(ppStatus, '.\a68pretty-status.txt');
        reset(ppStatus);
        errline:= '';
        allMessage:='';
        while not eof(ppStatus ) do begin   //read all lines
            readln(ppStatus, errline);
            allMessage:=allMessage+errline;
        end;
        closeFile(ppStatus);
        showmessage (allmessage);
        if allMessage = '' then begin  //empty, ok
            sleep(400);
            EditWin.Lines.LoadFromFile('.\a68pretty-result.txt');
            EditWin.SetFocus;
            EditWin.Modified := True;
        end
       else //error
          showMessage('Not reformatted: '+CRLF+allMessage);   //might be info on too many ]]]    //todo not pp?
        end;
    end;
end; //not configured
end;


//-------------------------------------------------------------------------------
procedure TTMainForm.XrefSpellButtonClick(Sender: TObject);
var                 //this code is also called froma menu, but this is special for a68
    line:string;
    userFileFolder:string;
begin

If  fileNameWithPath <>'' then begin   //work to do
    userFileFolder:=ExtractFileDir(fileNameWithPath);          //todo a68
    EditWin.Lines.SaveToFile( fileNameWithPath);
    EditWin.Modified := False;
     chdir(IDEdirectory);
    Assignfile(batFile,'dorun-cross.bat');
     rewrite(batFile);
     line:='a68crossref.exe '               //todo add path to crosref prog ie ide
        + fileNameWithPath ; //should be same as ide dir
     writeln(batfile,line);
       // writeln(batfile, 'pause');   //for debugging
     closeFile(batFile);
    openDocument( 'dorun-cross.bat');

      showmessage('Cross-ref placed in the file: ' + userFileFolder + 'crossref-result.txt');
    end;
end;

//-----------------------------------------------------------------------------

procedure TTMainForm.pasteMenuItemClick(Sender: TObject);
begin
       EditWin.PasteFromClipboard;
end;

 //-----------------------------------------------------------------------------

procedure TTMainForm.replaceMenuItemClick(Sender: TObject);
begin
    FPos:=0;
    replaceDialog1.execute;
end;

//---------------------------------------------------------------------------

procedure TTMainForm.copyMenuItemClick(Sender: TObject);
begin
 EditWin.CopyToClipboard;
end;
//---------------------------------------------------------------------------

 procedure TTMainForm.undoMenuItemClick(Sender: TObject);
begin
    editWin.undo;
end;
//----------------------------------------------------------------------------

procedure TTMainForm.cutMenuItemClick(Sender: TObject);
begin
EditWin.CutToClipboard;
end;
//--------------------------------------------------------------------------

procedure TTMainForm.editWinChange(Sender: TObject);
begin
end;

//---------------------------------------------------------------------------
procedure TTMainForm.findMenuItemClick(Sender: TObject);
begin
FPos:=0;
findDialog1.execute;
end;

//----------------------------------------------------------------------------
procedure TTMainForm.exitMenuItemClick(Sender: TObject);
begin
  Close;
end;

//-----------------------------------------------------------------------------

procedure TTMainForm.helpOnRideMenuClick(Sender: TObject);
var s:string;
begin
if a68Compiler <>'' then begin
  //  chdir(IDEdirectory);
    openDocument(IDEDirectory+'\'+'a68edhelp.txt');
end
else
    showMessage('Not configured yet - look at a68edhelp.txt  with a text editor.');
end;


//-----------------------------------------------------------------------------
procedure TTMainForm.closeMenuClick(Sender: TObject);
begin
 Close;
end;
//------------------------------------------------------------------------------

procedure TTMainForm.ChooseRedInterpClick(Sender: TObject);
var
    intro:string;
begin
 intro:='When the following window appears, browse to the  Algol68G compiler  file'+CRLF+CRLF+
          '(it has a name of the form:    a68g-N.N.N.exe  )'+CRLF+CRLF+
      '  and click "open".  '+CRLF + CRLF+
        'Do you wish to continue?';

if MessageDlg(intro, mtConfirmation,[mbYes,mbNo],0)=mrYes then begin
       OpenDialogExe.Filename:='';
       OpenDialogExe.title:='Selecting Algol68    .exe file';
       if OpenDialogExe.Execute then  begin

          if pos('68',lowercase(ExtractFileName( openDialogExe.filename)))= 0 then
             Showmessage('Error - you did not choose Algol68   ')
           else  Begin//ok
               a68Compiler:=openDialogExe.FileName;
            //   a68Compiler:=replaceIn('\bin', '', redfolder) + '\';

               ShowMessage('This program will now make use of this Algol68 system: '+CRLF+CRLF+     //full file name
                             openDialogExe.filename + CRLF+CRLF+ '   -  configuration completed.'+
                            CRLF+ 'Re-run a68ide for the change to take effect.'+CRLF+CRLF+
                            'Important:   you MUST read the  help info before using the pretty printer.');

               chDir(IDEDirectory);
               assignFile(outFile,'a68.ini');
               rewrite(outFile);
               writeln(outFile, a68Compiler);
                closeFile(outFile);
             end;
       end;
end; {user cancelled config}

end;
//----------------------------------------------------------------------------

procedure TTMainForm.CompileButtonClick(Sender: TObject);
  var params, line:string;
begin
if fileNameWithPath ='' then
    showMessage('No Algol68 program !  (not saved?)')
else if a68Compiler ='' then
      showmessage('No Algol68 system available - please see:  Tools | Configure.')
else if fileNamewithPath<>'' then

begin//compile
ErrorListBox.Clear;
EditWin.Lines.SaveToFile(fileNameWithPath);
EditWin.modified:=false;
params:='';  //prob not needed a68

Assignfile(batFile,'docomp.bat');
rewrite(batFile);
line:='"'+a68Compiler+'" ' + params + ' "'+fileNameWithPath+'"';
writeln(batfile, 'echo Wait...');
writeln(batfile,line);
writeln(batfile,'pause');   //keep compiler msgs onscreen
closeFile(batFile);
openDocument('docomp.bat');
end;
end;
//------------------------------------------------------------
procedure TTMainForm.consoleButtonClick(Sender: TObject);
var
line: string;

begin

//If  fileNameWithPath <>'' then begin   //work to do
     chdir(ExtractFileDir(fileNameWithPath));   //users a68 files
     Assignfile(batFile,'dorun-repl.bat');
     rewrite(batFile);
     line:= '"'+a68Compiler+ '"' +' --no-color ';
     writeln(batfile,line);
       writeln(batfile, 'pause');   //for debugging     todo
     closeFile(batFile);
    openDocument( 'dorun-repl.bat');
 //end;
end;

procedure TTMainForm.FragmentsButtonClick(Sender: TObject);
 begin
 chdir(IDEdirectory);
 openDocument('a68edfragments.txt');
 end;

//-----------------------------------------------------------------------------


procedure TTMainForm.newUnitppClick(Sender: TObject); //run a68 pp - new june 2021
 //pretty
var compilername,line ,params, userFileFolder, ppfname :string;
begin
params:='';
ErrorListBox.Clear;
userFileFolder:=ExtractFileDir(fileNameWithPath);
EditWin.Lines.SaveToFile(fileNameWithPath);
EditWin.modified:=false;

Assignfile(batFile, userFileFolder+ '\do68pp.bat');
rewrite(batfile);

line:=
'echo off'+crlf+
'if exist "bakname"  erase "bakname"'+crlf+
'copy "sourcename"  "bakname"'+crlf+
'if exist "ppfname"    erase "ppfname" '+crlf+      //eg myprog.f
'"a68g-2.8.3.exe"  --pretty-print  "sourcename" '+crlf+
'if not exist "ppfname" goto errors'+crlf+
'   goto  done'+crlf+
':errors'+crlf+
'echo'+crlf+
'echo FILE COULD NOT BE PRETTIED - MIGHT HAVE SYNTAX ERRORS'+crlf+
':done'+crlf;    //+  'pause'+crlf;

line:=replacein('sourcename',fileNameWithPath    ,line);

ppfname:=replacein('.a68', '.f', filenamewithpath);
line:=replacein('ppfname',ppfname    ,line);

line:=replacein('bakname', filenamewithpath+'.bak', line);
line:=replacein('a68g-2.8.3.exe',a68compiler   , line);
showmessage('After clicking OK, wait up to 10 seconds for pretty-printer status before editing file....');

writeln(batfile,line);
closeFile(batFile);
SetCurrentDir(userFileFolder);
openDocument(userfilefolder+'\do68pp.bat');

sleep(5000);   //let bat finish
if fileExists(ppfname) then begin     //eg  mine.f
           showmessage('Status:   File has been prettified.');
           EditWin.Lines.LoadFromFile(ppfname);
           EditWin.SetFocus;
           EditWin.Modified := True;

       end
      else begin//error
         showMessage('Status:   Not prettified - possible compilation errors!!');
       end;

end;



procedure TTMainForm.PairSplitterSide1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin

end;

procedure TTMainForm.PairSplitterSide2MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin

end;



//----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
procedure TTMainForm.newFileClickClick(Sender: TObject);
begin
if  OKtoCloseCurrentDoc then
     // if OpenDialog.Execute then

            begin
           //  ErrorListBox.clear;
            // EditWin.Lines.LoadFromFile(OpenDialog.FileName);
             SetFileName('' );    //OpenDialog.FileName);  // sets FileName with path!
             EditWin.SetFocus;
             EditWin.Modified := True;      // new code
             editWin.text:='#Program:   #'+CRLF+'print ("hello World");'+CRLF;
            // saveFileAs('newfile.a68');  //no, userchooses

            end;
end;

//--------------------------------------------------------------------------
procedure TTMainForm.redConsoleClick(Sender: TObject);
var line: string;
begin
Assignfile(batFile,'docomp.bat');
rewrite(batFile);
line:='"'+a68Compiler+'" ' + '--no-color';
writeln(batfile,line);
closeFile(batFile);
openDocument('docomp.bat');    //was execcommand
end;
//-----------------------------------------------------------------------------

procedure TTMainForm.RunExeButtonClick(Sender: TObject);
   var line, exeName:string;
begin
exeName:=replacein('.red', '.exe', fileNameWithPath);

if a68Compiler='' then
      showMessage('Algol68 system is unconfigured - use Tools menu.')
 else  if fileNameWithPath ='' then
     showMessage('No Algol68 program !   (not saved?)')
else if EditWin.modified=true then     //changed, not saved  -yet
     showmessage ('You  must compile your program. ')// compiledOK?  No class Load?  win empty...??
else  if not FileExists(exeName) then
    showMessage('File not found:  ' + exeName)
else               //nb if changed, saved, but not compiled, it runs earlier vn  todo note

begin       //run exe
ErrorListBox.Clear;
EditWin.Lines.SaveToFile(fileNameWithPath);
EditWin.modified:=false;

Assignfile(batFile,'comperrs.txt');

rewrite(batFile);
writeln(batfile, 'empty');
closeFile(batFile);

Assignfile(batFile,'dorunexe.bat');
rewrite(batFile);

line:= '"'+exeName+'"'  +' '+ commandLineArgs;
writeln(batfile,line);             //in same folder as Ride
writeln(batfile,'pause');           //keep screen

closeFile(batFile);
openDocument('dorunexe.bat');
end;
end;

//-----------------------------------------------------------------------------

procedure TTMainForm.ShowChosenInterpClick(Sender: TObject);
begin
if a68Compiler='' then
     showmessage('This program has not been informed about an Algol68 System.')
else
    showmessage('This program will use this Algol68 system:'+CRLF+
         '          '+  a68Compiler + CRLF+
         ' ');    //'in the same folder as Ride.' );
end;
//-----------------------------------------------------------------------------

procedure TTMainForm.biggerTextmenuItemClick(Sender: TObject);
const
fontMax=22;
begin
if EditWin.font.Size < fontMax then begin
    EditWin.font.Size :=    EditWin.font.Size+1;
    EditWin.SetFocus;
end;
end;
//-----------------------------------------------------------------------------

procedure TTMainForm.bracketsButtonClick(Sender: TObject);

var line, errLine, allMessage, resultFile, bracketsBat, bracketsExe: string;
begin
resultFile:='.\brackets-result.txt'; //const
bracketsBat:='.\dorun-brackets.bat';
bracketsExe:='.\a68brackets.exe';
chdir(IDEdirectory);
if not fileExists(bracketsExe) then
    showMessage('Error: missing brackets.exe file!')
 else
     If  FileNameWithPath <>'' then begin   //work to do
          EditWin.Lines.SaveToFile( FileNameWithPath);
          EditWin.Modified := False;

          Assignfile(batFile, bracketsBat);
           rewrite(batFile);
           line:=qu+bracketsExe+qu +'  '  + qu+FileNameWithPath+qu;
           writeln(batfile,line);
      //     writeln(batfile, qu+resultFile+qu);   //open txt file in an editor
           closeFile(batFile);
           opendocument(bracketsBat);

          sleep(400);        //seems ok

        Assignfile(ppStatus, resultFile);     //todo poor file name
        reset(ppStatus);
        errline:= '';          //not err  infact
        allMessage:='';
        while not eof(ppStatus ) do begin
            readln(ppStatus, errline);
            allMessage:=allMessage+errline
        end;
        closeFile(ppStatus);

          showMessage(allMessage);
        end;

   //  end;
end;

//-----------------------------------------------------------------------------

procedure TTMainForm.smallerTextMenuItemClick(Sender: TObject);
const
 fontMin=8;
begin
if EditWin.font.Size > fontMin then begin
    EditWin.font.Size :=    EditWin.font.Size-1;
    EditWin.SetFocus;
end;
end;
//-----------------------------------------------------------------------------

procedure TTMainForm.SpellCrossRefClick(Sender: TObject);
 var
    line:string;
    userFileFolder:string;
begin

If  fileNameWithPath <>'' then begin   //work to do
    userFileFolder:=ExtractFileDir(fileNameWithPath);          //todo a68
    EditWin.Lines.SaveToFile( fileNameWithPath);
    EditWin.Modified := False;

    Assignfile(batFile,'dorun-cross.bat');
     rewrite(batFile);
     line:='cross-ref-ide.exe '
        + fileNameWithPath ; //should be same as ide dir
     writeln(batfile,line);
       // writeln(batfile, 'pause');   //for debugging
     closeFile(batFile);
    openDocument( 'dorun-cross.bat');

         //the red crossref prog uses e.g myprog.Red, puts xref in myprog.red-cross.txt
      showmessage('Cross-ref placed in the file: ' + fileNameWithPath + '-cross.txt');
    end;
end;

//-------------------------------------------------------------------------------

procedure TTMainForm.FormCloseQuery(Sender: TObject; var CanClose: boolean);
begin
   if OKtoCloseCurrentDoc then
      CanClose := true
   else
      CanClose := false;
end;

//-----------------------------------------------------------------------------

// --- FORM Create and Close , init
procedure TTMainForm.FormCreate(Sender: TObject);
var
   iniName:string;
begin
ClearEditWin;
EditWin.HideSelection := false; // show selection when EditWin loses focus
//   ShowCursorPos;
a68Compiler:='';
IDEDirectory:=GetCurrentDir;      // where ved was run from
fileNameWithPath:='';
commandLineArgs:='';

//get ini file if it exists .  line 1 is red sys, li
// line 2 an initial use dir path //used?
iniName:='a68.ini';
chDir(IDEDirectory);       //always in IDE dir

editwin.Gutter.visible:=true;   // line numbers showing

if fileExists(iniName) then begin
    AssignFile(inFile, iniName);
    reset(infile);
    readln(inFile,a68Compiler);
    a68Compiler:=trim(a68Compiler);
    readln(infile,initialUserDir);
    initialUserDir:=trim(initialUserDir);
    openDialog.initialDir:= initialUserDir;
    saveDialog.initialDir:=initialUserDir;
    closeFile(infile);
    end;

end;

//-------------------------------------------------------------------------------
end.

